package edu.lawrence.chatclient;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import javafx.application.Platform;
import javafx.scene.control.TextArea;

public class ChatGateway {
    private PrintWriter outputToServer;
    private BufferedReader inputFromServer;
    private String handle;
    
    // Establish the connection to the server.
    public ChatGateway() {}
    
    public void setHandle(String handle) {
        this.handle = handle;
    }
    
    public void readTranscript(TextArea textArea) {
        try {
            // Create a socket to connect to the server
            Socket socket = new Socket("localhost", 8001);

            // Create an input stream to read data from the server
            BufferedReader input = new BufferedReader(new InputStreamReader(socket.getInputStream()));

            while(true) {
                String comment = input.readLine();
                if(comment == null)
                    break;
                else if(comment.length() > 0){
                    final String newLine = comment + "\n";
                    Platform.runLater(()->textArea.appendText(newLine));
                }
            }
        } catch (IOException ex) {
            
        }
    }

    public void openConnection() {
        try {
            // Create a socket to connect to the server
            Socket socket = new Socket("localhost", 8000);

            // Create an output stream to send data to the server
            outputToServer = new PrintWriter(socket.getOutputStream());

            // Create an input stream to read data from the server
            inputFromServer = new BufferedReader(new InputStreamReader(socket.getInputStream()));

        } catch (IOException ex) {
            
        }
    }
    
    // Send a new comment to the server.
    public void sendComment(String comment) {
        outputToServer.println(handle + "> " + comment);
        outputToServer.flush();
    }

    // Fetch comment from the server.
    public String getComment() {
        String comment = "";
        try {
            comment = inputFromServer.readLine();
        } catch (IOException ex) {
            
        }
        return comment;
    }
}
